#include <stdio.h>
#include <stdlib.h>

  /* Vezane liste - Primjer 6.
     Brisanje prvog parnog elementa (s pravog mjesta) u listi.
  */

/* ======================================================================== */

    /* Tip za pokazivac na element liste. */

typedef struct _element *lista;

    /* Tip za element liste. */

typedef struct _element {
    int broj;            /* Sadrzaj je broj. */
    lista sljed;         /* Pokazivac na sljedeci element u listi. */
} element;

/* ======================================================================== */

lista obrisi_prvi_parni(lista prvi)
{
        /* Brise prvi parni element u listi.
           Ako ga nema - ne radi nista. */

    lista preth, pom;

    if (prvi == NULL) return NULL;   /* Ne treba. */

    pom = prvi;
/*    NE treba inicijalizacija preth = NULL. Razlog:
      Kod izbacivanja prvog elementa, koristimo
      uvjet (pom == prvi), a ne (preth == NULL). */

        /* Nadji trazeni element, ako ga ima. */
    while (pom != NULL && pom->broj % 2 != 0) {
        preth = pom;
        pom = preth->sljed;    /* <=> pom = pom->sljed; */
    }

        /* Test jesmo li nasli parnog. Ako jesmo,
           lista nije prazna i preth nije zadnji. */
    if (pom != NULL) {

/*    Ispod je obrisi_iza(prvi, preth) s promjenom
      uvjeta i BEZ postavljanja pom (to vec je).
      To radi i za pom == prvi (tu je pom != NULL).
*/
        if (pom == prvi)    /* preth ne treba. */
            prvi = prvi->sljed;
        else    /* Tu je pom == preth->sljed. */
            preth->sljed = pom->sljed;

        free(pom);
    }    /* Kraj if (pom != NULL). */

    return prvi;
}

/* ======================================================================== */

    /* Ispod su funkcije za osnovne operacije s listama. */

/* ======================================================================== */

lista kreiraj_straga(lista prvi, lista *p_zadnji, int broj)
{
        /* Vraca zadnji kroz varijabilni argument - pokazivac p_zadnji. */

    lista zadnji = *p_zadnji;
    lista novi = NULL;
/*
    if ((novi = (lista) malloc(sizeof(element))) == NULL)
*/
    novi = (lista) malloc(sizeof(element));
    if (novi == NULL) {
        printf("Alokacija nije uspjela.\n");
        exit(EXIT_FAILURE);    /* exit(1); */
    }

    novi->broj = broj;
    novi->sljed = NULL;

    if (prvi == NULL)
        prvi = novi;
    else
        zadnji->sljed = novi;

/* Ne treba:
    zadnji = novi; *p_zadnji = zadnji;
*/
    *p_zadnji = novi;    /* Vrati novi zadnji! */

    return prvi;
}

/* ======================================================================== */

lista obrisi_listu(lista prvi)
{
    lista pom;
/*
    while (prvi != NULL)
        prvi = obrisi_prvog(prvi);
*/
    while (prvi != NULL) {
        pom = prvi;
        prvi = prvi->sljed;
        free(pom);
    }

    return NULL;    /* <=> return prvi; */
}

/* ======================================================================== */

int broj_elemenata(lista prvi)
{
    lista pom;
    int brojac = 0;

    for (pom = prvi; pom != NULL; pom = pom->sljed)
        ++brojac;

    return brojac;
}

/* ======================================================================== */

void ispisi_listu(lista prvi)
{
    lista pom;
    int brojac = 0;

    for (pom = prvi; pom != NULL; pom = pom->sljed) {
        printf(" Element %2d, broj = %2d\n",
               ++brojac, pom->broj);
    }

    return;
}

/* ======================================================================== */

int main(void)
{
    lista prvi = NULL;    /* Prazna lista! */
    lista zadnji;
    int broj, i;

        /* Punjenje liste straga. */

        /* Citanje niza brojeva za listu, do broj = 0.
           To je oznaka kraj niza, ali nije clan niza. */
        /* Poredak brojeva u listi je isti kao redoslijed
           citanja, jer dodajemo na kraj liste. */

    printf("Upisite niz cijelih brojeva (0 = kraj).\n");
    do {
        printf("Sljedeci broj:\n");
        scanf("%d", &broj);
        if (broj != 0)
            prvi = kreiraj_straga(prvi, &zadnji, broj);
    } while (broj != 0);

        /* Ispis broja elemenata i cijele liste. */

    printf("\n");
    printf(" Broj elemenata u listi = %d\n",
           broj_elemenata(prvi));
    ispisi_listu(prvi);


        /* Brisanje trazenih iz liste. */
        /* 6 puta obrisi prvi parni iz liste. */

    for (i = 1; i <= 6; ++i) {
        prvi = obrisi_prvi_parni(prvi);
        printf("\n Obrisan prvi parni element.\n");
        printf(" Broj elemenata u listi = %d\n",
               broj_elemenata(prvi));
        ispisi_listu(prvi);
    }

        /* Obrisi cijelu listu. */

    prvi = obrisi_listu(prvi);

    return 0;
}
